/*
This is a part of the IconDesk source code.

Copyright (C) 2003 Erik Christiansson, aka Sci
www.alphafish.com
erik@alphafish.com

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

#include "FileIcon.h"

FileIcon::FileIcon()
{
	_pidl = NULL;
}

FileIcon::~FileIcon()
{
	if(_pidl) {
		LPMALLOC pMalloc;
		if(SHGetMalloc(&pMalloc) == NOERROR) {
			pMalloc->Free(_pidl);
			pMalloc->Release();
		}
	}
}

void FileIcon::SetPIDL(LPITEMIDLIST pidl)
{
	_pidl = pidl;
}

void FileIcon::Execute(LPCSTR szCommand)
{
	if(!stricmp(szCommand, ".none")) {
		return;
	}
	else if(!stricmp(szCommand, ".context")) {
		ShellContextMenu* scm = new ShellContextMenu();
		scm->ShowContextMenu(_pidl, hParent);
		delete scm;
		InvalidateRect(hParent, NULL, TRUE);
	}
	else if(!stricmp(szCommand, ".open")) {
		ShellExecute(NULL, NULL, filename, NULL, NULL, SW_NORMAL);
	}
}
