/////////////////////////////////////////////////////////////////////
// class to show shell contextmenu of files/folders/shell objects
// developed by R. Engels 2003
//
// Modified by Erik Christiansson to fit in IconDesk
/////////////////////////////////////////////////////////////////////

#ifndef __SHELLCONTEXTMENU_H
#define __SHELLCONTEXTMENU_H

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include <windows.h>
#include "pidl.h"

class ShellContextMenu  
{
public:
	HMENU GetMenu();
	UINT ShowContextMenu(LPITEMIDLIST pidl, HWND hWnd);
	ShellContextMenu();
	virtual ~ShellContextMenu();

private:
	int nItems;
	BOOL bDelete;
	HMENU _hMenu;
	IShellFolder* m_psfFolder;
	LPITEMIDLIST* m_pidlArray;	
	
	void SetObjects(LPITEMIDLIST pidl);
	void InvokeCommand(LPCONTEXTMENU pContextMenu, UINT idCommand);
	BOOL GetContextMenu(void** ppContextMenu, int& iMenuType);
	HRESULT SHBindToParentEx(LPCITEMIDLIST pidl, REFIID riid, VOID **ppv, LPCITEMIDLIST *ppidlLast);
	static LRESULT CALLBACK HookWndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam);

};

#endif//__SHELLCONTEXTMENU_H
